function getNSIFileFromURI (f)
{
  var IOService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);

  if (typeof (f) == "string")
    {
      var tempLocalFile;

      try 
        {
          var fileHandler = IOService.getProtocolHandler('file').QueryInterface(Components.interfaces.nsIFileProtocolHandler);
          tempLocalFile = fileHandler.getFileFromURLSpec(f);
        }
      catch(e) 
        { // [[interchangeability for Mozilla 1.1]]
          try 
            {
              tempLocalFile = IOService.getFileFromURLSpec(f);
            }
          catch(ex) 
            { // [[interchangeability for Mozilla 1.0.x]]
              tempLocalFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
              IOService.initFileFromURLSpec(tempLocalFile, f);
            }
        }
      
      return tempLocalFile;
    }

  return f;
}

function getFileExtension (s)
{
  if (s.length == 0)
    return "";

  var dot = s.lastIndexOf (".");
  if (dot == -1)
    return "";

  return s.substr (dot, s.length);
} 

function stripFilename (s, max)
{
  if (s.length <= max)
    return s;

  var ext = getFileExtension (s);
  
  return s.substr (0, max) + "~" + ext;
}

/* auctionsStrings.getFormattedString */

var listObserver = {
 onDragStart: function (evt,transferData,action)
 { 
   var txt=evt.target.getAttribute("elem"); 
   transferData.data=new TransferData(); 
   transferData.data.addDataForFlavour("text/unicode",txt); 
 }
}; 

var boardObserver = { 
 getSupportedFlavours : function () 
 { 
   var flavours = new FlavourSet ();
   flavours.appendFlavour ("text/x-moz-url");
   flavours.appendFlavour ("application/x-moz-file", "nsIFile");
   return flavours; 
 }, 

 onDragOver: function (evt,flavour,session)
 {
 }, 

 onDrop: function (evt,dropdata,session)
 {
   if (dropdata.data != "")
     {
       var auctionsStrings = document.getElementById ("auctionsStrings");

       var f = getNSIFileFromURI (dropdata.data);

       if (!f.isFile ())
	 {
	   var s = auctionsStrings.getFormattedString ("notfile", [f.leafName]);
	   alert (s);
	   return;
	 }

       this.changeFilenameAndIcon (f.leafName);
       this.modifyFileInfoTree (f);
     }
   else
     {
       alert ("dropdata.data is NULL.");
     }
 },

 changeFilenameAndIcon: function (leafName)
 {
   var pFilename = document.getElementById ("auctionItemFileName");
   pFilename.value = stripFilename (leafName, 20);
   pFilename.disabled = false;
 },

 modifyFileInfoTree: function (f)
 {
   var auctionsStrings = document.getElementById ("auctionsStrings");
   var fileinfo = document.getElementById ("auctionItemFileName");
 
   getthetree().DeleteAll ();
   getthetree().topcategory ('thetreechildren', auctionsStrings.getString ("path"), f.path);
   getthetree().topcategory ('thetreechildren', auctionsStrings.getString ("filesize"), commaFormat (f.fileSize, ',') + " bytes");
   var hash = calcHash (f);
   getthetree().topcategory ('thetreechildren', auctionsStrings.getString ("hash"), hash);

   fileinfo.setAttribute ("FI_Name", f.leafName);
   fileinfo.setAttribute ("FI_Path", f.path);
   fileinfo.setAttribute ("FI_FileSize", f.fileSize);
   fileinfo.setAttribute ("FI_Hash", hash);
 }
};

function calcHash (f)
{
  var hash = Components.classes["@fileauction.com/hash/fa;1"]
                       .createInstance(Components.interfaces.IFileAuctionHash);
  var file = Components.classes["@mozilla.org/file/local;1"]
                       .createInstance(Components.interfaces.nsILocalFile);
  file.initWithPath (f.path);

  return hash.calc (file);
}

function commaFormat (num , sep) 
{ 
  var n = '' + num;
  var numl  = n.length;
  var i = n.indexOf ('.');
  var fract = '';
  
  if (i > -1)
    {
      numl -= n.length-i;
      fract = n.substring (i);
    }
  if (numl > 3)
    {
      var s, dl = numl%3;
      var str = (dl > 0) ? n.substring(0,dl):'';
      var max = Math.floor (numl/3);
      for (i=0 ; i < max ; i++)
	{
	  s = n.substring (dl + i * 3, dl + i * 3 + 3);
	  str += (dl==0 && i==0) ? s : sep+s;
	}
      return str+fract;
    }
  else
    return n;
}
