var RDF = '@mozilla.org/rdf/rdf-service;1';
RDF = Components.classes[RDF].getService ();
RDF = RDF.QueryInterface (Components.interfaces.nsIRDFService);

var browseMenuInited = 0;
prefs.setBoolPref ('fileauction.adWords.ready', false);

function setTotalRemainMoneyLabel ()
{
  var rs = getRemainMoney ();
  var lb = document.getElementById ("TotalRemainMoney");
  
  var s = prefs.getCharPref ("fileauction.money.user.currency");
  var l = document.getElementById ("TotalRemainMoneyImage");

  if (s == "USD")
    l.src = "chrome://fa/skin/currency/dollar.png";
  else if (s == "WON")
    l.src = "chrome://fa/skin/currency/won.png";
  else if (s == "YEN")
    l.src = "chrome://fa/skin/currency/yen.png";
  else if (s == "EUR")
    l.src = "chrome://fa/skin/currency/euro.png";

  lb.value = rs;
  saveCurrentCurrency (s);
}

function enableBidBuyoutButton ()
{
  var i;

  i= document.getElementById ("tryBidButton");
  i.disabled = false;
  i= document.getElementById ("tryBuyoutButton");
  i.disabled = false;
  i= document.getElementById ("TotalRemainMoney");
  i.disabled = false;
  i= document.getElementById ("BidText");
  i.disabled = false;
  i= document.getElementById ("inputNewBid");
  i.disabled = false;
  i.value = "0";
  i.setAttribute ("onfocus", "this.select ();");
}

function refreshFiltersTree ()
{
  var t = document.getElementById ("browseFiltersTree");
  t.datasources = "";
  t.datasources = URL_category;
}

function refreshAds ()
{
  prefs.setBoolPref ('fileauction.adWords.ready', false);

  var t = document.getElementById ("AdList");
  t.datasources = "rdf:null";
  t.datasources = URL_ads;
  t.clearSelection ();
  
  setTimeout ("prefs.setBoolPref ('fileauction.adWords.ready', true)", 1000);
}

function initAdWords ()
{
  var t = document.getElementById ("AdList");
  t.clearSelection ();
  if (t.selectedIndex == -1)
    {
      prefs.setBoolPref ('fileauction.adWords.ready', true);
      return;
    }

  t.selectedItem.setAttribute ("selected", "false");
  prefs.setBoolPref ('fileauction.adWords.ready', true);
}

function onLoadBrowse ()
{
  try 
    {
      if (checkLoginStatus ())
	{
	  setTotalRemainMoneyLabel ();
	  enableBidBuyoutButton ();
	  if (prefs.prefHasUserValue ("fileauction.money.user.currency"))
	    changeBottomMenuCurrency (prefs.getCharPref ("fileauction.money.user.currency"));

	  browseMenuInited = 1;
	}
      showItemWhenSometimes ();
      refreshFiltersTree ();
      refreshAds ();
      initAdWords ();
    }
  catch (e)
    {
      alert (e);
    }
}

function onUnloadBrowse ()
{
}

function showItemWhenSometimes ()
{
  /* fileauction://|itemId|1|/ */
  var itemURI;

  if (!prefs.prefHasUserValue ("fileauction.default.item"))
    return;

  itemURI = prefs.getCharPref ("fileauction.default.item");
  if (!itemURI.length)
    return;

  if (itemURI.indexOf ("fileauction://") != 0)
    return;

  var c = itemURI.substr (14, itemURI.length - 15);
  var a = new Array ();
  a = c.split ('|');

  if (a[1] == 'itemId')
    {
      var searchURL = URL_search + "?i=" + a[2];
      var itemList = document.getElementById ("itemListTree");
      itemList.datasources = searchURL;
      var itemNoth = document.getElementById ("NothingToDisplay");
      itemNoth.hidden = true;
      itemList.hidden = false;
    }

  prefs.setCharPref ("fileauction.default.item", "");
}

function selectItemListTree ()
{
  if (!checkLoginStatus ())
    return;

  var t = document.getElementById ("itemListTree");

  if (t.currentIndex == -1)
    return;

  var cl = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("BrowseColumnCurrentBid"));

  var i = document.getElementById ("inputNewBid");
  i.value = cl;
}

function browseBidSelectedItem (is_buyout)
{
  if (!checkTimesLogin ())
    return -1;

  if (browseMenuInited == 0 && checkLoginStatus ())
    onLoadBrowse ();

  var browseStrings = document.getElementById ("browseStrings");
  var c = document.getElementById ("CurrencyImage");
  var t = document.getElementById ("itemListTree");

  if (t.currentIndex == -1)
    return 0;

  var co = t.treeBoxObject.view.getItemAtIndex (t.currentIndex);
  var uid = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("BrowseColumnUID"));
  var cp = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("BrowseColumnCurrentBid"));
  var cu = t.treeBoxObject.view.getImageSrc (t.currentIndex, t.columns.getNamedColumn ("BrowseColumnCurrentBid"));
  var v = document.getElementById ("inputNewBid");

  if (cp == " " + browseStrings.getString ("free"))
    v.value = 0;

  if (c.getAttribute ("symbol") != getCurrencyStrFromURL (cu)
      && v.value != 0)
    {
      alert (browseStrings.getString ("incorrectcurrency"));
      return 0;
    }

  price = v.value * 1;
  if (is_buyout)
    {
      var bp = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("BrowseColumnBuyoutPrice"));
      if (bp == " " + browseStrings.getString ("free"))
	price = 0;
      else
	price = bp * 1;
    }
    
  qstr =    "c=" + c.getAttribute ("symbol")
         + "&v=" + price
         + "&i=" + uid;

  var req = new XMLHttpRequest ();
  req.open ("POST", URL_bid, false);
  req.setRequestHeader ('Content-Type', 'application/x-www-form-urlencoded');
  req.send (qstr);

  if (req.readyState == 4 && req.status == 200)
    {
      if (!fa_error (req.responseText))
	{
	  try
	    {
	      prefs.setBoolPref ("fileauction.money.init", false);
	      setTotalRemainMoneyLabel ();

	      if (is_buyout)
		fa_showMsg ("물품 즉시구매", browseStrings.getString ("buyoutok"));
	      else
		fa_showMsg ("물품 입찰", browseStrings.getString ("bidok"));
	      co.parentNode.removeChild (co);
	    }
	  catch (e) { alert (e); }
	}
    }

  return 0;
}

function changeBottomMenuCurrency (s)
{
  var l = document.getElementById ("CurrencyImage");
  
  if (s == "USD")
    l.src = "chrome://fa/skin/currency/dollar.png";
  else if (s == "WON")
    l.src = "chrome://fa/skin/currency/won.png";
  else if (s == "YEN")
    l.src = "chrome://fa/skin/currency/yen.png";
  else if (s == "EUR")
    l.src = "chrome://fa/skin/currency/euro.png";

  l.setAttribute ("symbol", s);
  saveCurrentCurrency (s);
}

function searchCategory ()
{
  //var browseStrings = document.getElementById ("browseStrings");
  //var c = document.getElementById ("CurrencyImage");

  var t = document.getElementById ("browseFiltersTree");
  if (t.currentIndex == -1)
    return;
  var co = t.treeBoxObject.view.getItemAtIndex (t.currentIndex);
  var cid = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("categoryFilterUID"));

  itemList = document.getElementById ("itemListTree");
  itemList.datasources = URL_search + "?cid=" + cid;

  itemNoth = document.getElementById ("NothingToDisplay");
  itemNoth.hidden = true;
  itemList.hidden = false;

  refreshAds ();
}

function openFindBar ()
{
  window.parent.openFindBar ();
  window.parent.selectFindBar ();
  window.parent.focusFindBar ();
}

function openSendMailTo ()
{
  var t = document.getElementById ("itemListTree");
  
  if (t.currentIndex == -1)
    {
      alert ("아이템을 선택하지 않았습니다.");
      return;
    }

  var seller = t.treeBoxObject.view.getCellText (t.currentIndex, 
						 t.columns.getNamedColumn ("ID_ItemListTreeSeller"));

  prefs.setCharPref ("fileauction.mail.to", seller);
  window.parent.gFileAuctionWindow.menusSelectionChangedCore ("paneSendMail");
}

function copySellerRSSAddr ()
{
  var t = document.getElementById ("itemListTree");
  if (t.currentIndex == -1)
    return;
  var id = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("ID_ItemListTreeSeller"));

  const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
                                     .getService(Components.interfaces.nsIClipboardHelper);
  gClipboardHelper.copyString ("http://www.fatalbid.com/fa/rss/seller.php?id=" + id);

  fa_showMsg ("판매자 RSS 주소 복사", "주소가 클립보드에 복사되었습니다.");
}

function openAdWords ()
{
  window.parent.paneBody.location.href = "http://www.fatalbid.com/fa/home/adwords/";
}

function onAdListSelected (evt)
{
  if (!prefs.getBoolPref ('fileauction.adWords.ready'))
    return;

  var t = document.getElementById ("AdList");
  if (t.selectedIndex == -1)
    return;

  var link = t.selectedItem.getAttribute ("link");

  var ioservice = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService);
  var uriToOpen = ioservice.newURI (link, null, null);
  var extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
                        .getService(Components.interfaces.nsIExternalProtocolService);
  extps.loadURI (uriToOpen, null);
}

function showItemsOfSeller ()
{
  var t = document.getElementById ("itemListTree");
  if (t.currentIndex == -1)
    return;

  var cl = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("ID_ItemListTreeSeller"));

  var searchURL = URL_search + "?s=" + cl;
  var itemList = document.getElementById ("itemListTree");
  itemList.datasources = searchURL;

  refreshAds ();
}

