var current_page = 1;
var current_total = 0;
var current_query = "";
var current_cid = 0;
var start;
var end;

function initFindBarGlobalVariables ()
{
  current_page = 1;
  current_query = "";
}

function initFindBar ()
{
  getgWindow().addEventListener("keypress", onBrowserKeyPress, false);
}

function uninitFindBar()
{
  getgWindow().removeEventListener("keypress", onBrowserKeyPress, false);
}

function focusFindBar()
{
  var findField = document.getElementById("find-field");
  findField.focus();
}

function selectFindBar ()
{
  var findField = document.getElementById("find-field");
  findField.select();
}

function closeFindBar ()
{     
  // ensure the dom is ready...
  setTimeout (delayedCloseFindBar, 0);
}

function delayedCloseFindBar()
{
  var findToolbar = document.getElementById("FindToolbar");

  findToolbar.hidden = true;
}

function openFindBar()
{
  initFindBarGlobalVariables ();

  var findToolbar = document.getElementById("FindToolbar");

  if (findToolbar.hidden)
    {
      findToolbar.hidden = false;

      var statusIcon = document.getElementById("find-status-icon");
      var statusText = document.getElementById("find-status");
      var findField = document.getElementById("find-field");
      findField.removeAttribute("status");
      statusIcon.removeAttribute("status");
      statusText.value = "";

      return true;
    }

  return false;
}

const CHAR_CODE_F = "f".charCodeAt(0);
const CHAR_CODE_SLASH = "/".charCodeAt(0);

const CHAR_CODE_1 = "1".charCodeAt(0);
const CHAR_CODE_2 = "2".charCodeAt(0);
const CHAR_CODE_3 = "3".charCodeAt(0);
const CHAR_CODE_4 = "4".charCodeAt(0);
const CHAR_CODE_5 = "5".charCodeAt(0);

function onBrowserKeyPress (evt)
{
  /* ctrl + f */
  if ((evt.ctrlKey && evt.charCode == CHAR_CODE_F)
      || (evt.charCode == CHAR_CODE_SLASH 
	  && document.getElementById("FindToolbar").hidden == true))
    {
      if (gCurrentScreen == "paneBrowse")
	{
	  openFindBar ();
	  selectFindBar ();
	  focusFindBar ();
	}
    }

//@line 116 "/Users/weongyo/Developments/fileauction/src/chrome/content/findBar.js"

//@line 119 "/Users/weongyo/Developments/fileauction/src/chrome/content/findBar.js"
  if ((evt.ctrlKey  
       && (evt.charCode == CHAR_CODE_1
           || evt.charCode == CHAR_CODE_2
           || evt.charCode == CHAR_CODE_3
           || evt.charCode == CHAR_CODE_4
           || evt.charCode == CHAR_CODE_5)))
    {
      if (evt.charCode == CHAR_CODE_1)
        gFileAuctionWindow.menusSelectionChangedCore ("paneBrowse");
      if (evt.charCode == CHAR_CODE_2)
        gFileAuctionWindow.menusSelectionChangedCore ("paneBids");
      if (evt.charCode == CHAR_CODE_3)
        gFileAuctionWindow.menusSelectionChangedCore ("paneAuctions");
      if (evt.charCode == CHAR_CODE_4)
        gFileAuctionWindow.menusSelectionChangedCore ("paneInbox");
      if (evt.charCode == CHAR_CODE_5)
        gFileAuctionWindow.menusSelectionChangedCore ("paneSendMail");
    }
//@line 159 "/Users/weongyo/Developments/fileauction/src/chrome/content/findBar.js"
}

function onFindBarKeyPress (evt)
{
  if (evt.keyCode == KeyEvent.DOM_VK_RETURN) 
    {
      itemsearch ();
    }
}

function onFindBarBlur ()
{
  /* nothing to do */
}

function throbber_enable ()
{
  throbber = document.getElementById ("navigator-throbber");
  throbber.setAttribute ("busy", "true");
}

function throbber_disable ()
{
  throbber = document.getElementById ("navigator-throbber");
  throbber.setAttribute ("busy", "false");
}

function disableFindButtons ()
{
  var b = document.getElementById ("find-next");
  b.disabled = true;

  b = document.getElementById ("find-previous");
  b.disabled = true;
}

function enableFindButtons ()
{
  var b = document.getElementById ("find-next");
  if (current_total > end)
    b.disabled = false;
  else
    b.disabled = true;

  b = document.getElementById ("find-previous");
  if (current_page <= 1)
    b.disabled = true;
  else
    b.disabled = false;

  //b = document.getElementById ("highlight");
  //b.disabled = false;
}

function changeFindLabelStatus ()
{
  var mainStrings = document.getElementById ("mainStrings");
  var f = document.getElementById ("find-status");
  
  start = 50 * (current_page - 1) + 1;
  end = start + 50;
  if (end > current_total)
    end = current_total;

  if (current_total == 0)
    f.value = mainStrings.getString ("notfound");
  else
    f.value = mainStrings.getFormattedString ("findfield", [start, end, current_total]);

  disableFindButtons ();
  setTimeout ("enableFindButtons ()", 5000);
}

function refreshAds ()
{
  prefs.setBoolPref ('fileauction.adWords.ready', false);

  var bdoc = window.paneBody.document;
  var a = bdoc.getElementById ("AdList");
  
  a.datasources = "rdf:null";
  a.datasources = URL_ads;
  a.clearSelection ();

  setTimeout ("prefs.setBoolPref ('fileauction.adWords.ready', true)", 1000);
}

function itemSearchNext ()
{
  var bdoc = window.paneBody.document;
  current_page++;
  var searchURL = URL_search + "?q=" + escape (current_query) + "&p=" + current_page;
  throbber_enable ();
  itemList = bdoc.getElementById ("itemListTree");
  itemList.datasources = searchURL;

  refreshAds ();
  changeFindLabelStatus ();
  throbber_disable ();
}

function itemSearchPrevious ()
{
  var bdoc = window.paneBody.document;
  current_page--;
  var searchURL = URL_search + "?q=" + escape (current_query) + "&p=" + current_page;
  throbber_enable ();
  itemList = bdoc.getElementById ("itemListTree");
  itemList.datasources = searchURL;
  refreshAds ();

  changeFindLabelStatus ();
  throbber_disable ();
}

function getCIDFromCategory ()
{
  var bdoc = window.paneBody.document;
  var t = bdoc.getElementById ("browseFiltersTree");

  if (t.currentIndex != -1)
    {
      var co = t.treeBoxObject.view.getItemAtIndex (t.currentIndex);
      var cid = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("categoryFilterUID"));
      
      return cid;
    }
  
  return 0;
}

function itemsearch ()
{
  var bdoc = window.paneBody.document;
  var findField = document.getElementById ("find-field");
  current_query = findField.value.replace (/&/g, "%26");
  current_cid = getCIDFromCategory ();

  var searchURL = URL_search + "?q=" + escape (current_query) + "&p=" + current_page + "&c=" + current_cid;

  throbber_enable ();

  itemList = bdoc.getElementById ("itemListTree");
  itemList.datasources = searchURL;

  itemNoth = bdoc.getElementById ("NothingToDisplay");
  itemNoth.hidden = true;

  itemList.hidden = false;

  var req = new XMLHttpRequest ();
  req.open ("GET", searchURL + "&m=count", false);
  req.send (null);
  if (req.readyState == 4 && req.status == 200)
    current_total = req.responseText * 1;

  refreshAds ();
  changeFindLabelStatus ();

  throbber_disable ();
}
