var RDF = '@mozilla.org/rdf/rdf-service;1';
RDF = Components.classes[RDF].getService ();
RDF = RDF.QueryInterface (Components.interfaces.nsIRDFService);

function refreshInbox ()
{
  var i = document.getElementById ("InboxList");
  i.datasources = "";
  i.datasources = URL_inbox;
}

function onLoadInbox ()
{
  try
    {
      if (!checkTimesLogin ())
	return -1;
      
      if (!checkLoginStatus ())
	{
	  s = document.getElementById ("SignUpFirst");
	  s.hidden = false;
	  s = document.getElementById ("InboxBody");
	  s.hidden = true;
	  return 0;
	}
      
      refreshInbox ();
    }
  catch (e)
    {
      alert (e);
    }

  return 0;
}

function onUnloadInbox ()
{
}

function checkReadMark (uid)
{
  var req = new XMLHttpRequest ();
  req.open ("GET", URL_mark + "?i=" + uid, false);
  req.send (null);

  if (req.readyState == 4 && req.status == 200)
    {
      //if (req.responseText.charAt (0) == "1")
      //  refreshInbox ();
    }
}

function checkMailSenderConnection ()
{
  var v = document.getElementById ("InboxBodyFrom");
  var mid = v.getAttribute ("uid");

  v = document.getElementById ("InboxBrowser");
  v.contentDocument.location.href = "http://www.fatalbid.com/fa/server/checkSellerConn.php?mail_id=" + mid;
}

function onListInboxDoubleClick (evt)
{
  var mh = document.getElementById ("msgHeaderView");
  var inboxStrings = document.getElementById ("inboxStrings");
  var lb = document.getElementById ("InboxList");
  var v, a;

  mh.hidden = false;
  if (getRDFvalue (lb, "type") == "Trade")
    mh.hidden = true;

  v = document.getElementById ("InboxBrowser");
  v.contentDocument.body.innerHTML = getRDFvalue (lb, "body");

  v = document.getElementById ("InboxBodyFrom");
  v.setAttribute ("value", getRDFvalue (lb, "from"));
  v.setAttribute ("uid", lb.selectedItem.getAttribute ("uid"));
  
  v = document.getElementById ("InboxBodySubject");
  v.value = getRDFvalue (lb, "subject");

  onListProcessAttachments (lb);

  var d = getRDFvalue (lb, "delivery");
  var m = getRDFvalue (lb, "money") * 1;

  if (m > 0)
    {
      if (d == "SM")
	{
	  document.getElementById ("MoneyInboxLabel").value = inboxStrings.getString ("rm");
	  document.getElementById ("SaveMoneyButton").label = inboxStrings.getString ("rmbutton");
	}
      else if (d == "COD")
	{
	  document.getElementById ("MoneyInboxLabel").value = inboxStrings.getString ("mp");
	  document.getElementById ("SaveMoneyButton").label = inboxStrings.getString ("mpbutton");
	}

      v = document.getElementById ("currencyReceivedMoney");
      v.src = getCurrencyURLFromStr (getRDFvalue (lb, "currency"));
      v = document.getElementById ("ReceiveMoneyLabel");
      v.value = getRDFvalue (lb, "money");

      if (d == "COD" && getRDFvalue (lb, "is_paid") == "1")
	document.getElementById ("InboxMoneyBox").hidden = true;
      else
	document.getElementById ("InboxMoneyBox").hidden = false;
    }
  else
    document.getElementById ("InboxMoneyBox").hidden = true;

  checkReadMark (getRDFvalue (lb, "uid"));
}

function getRDFvalue (lb, prop)
{
  var i = document.getElementById ("InboxBrowseMail");

  var source   = RDF.GetResource ("http://www.fileauction.com/inbox/" + lb.selectedItem.getAttribute ("uid"));
  var property = RDF.GetResource ("http://www.fileauction.com/rdf#" + prop);
  var test = lb.database.GetTarget (source, property, true);

  if (test instanceof Components.interfaces.nsIRDFLiteral)
    return test.Value;

  return "";
}

function setRDFvalue (lb, prop, aValue)
{
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
  var i = document.getElementById ("InboxBrowseMail");

  var source   = RDF.GetResource ("http://www.fileauction.com/inbox/" + lb.selectedItem.getAttribute ("uid"));
  var property = RDF.GetResource ("http://www.fileauction.com/rdf#" + prop);
  var node = lb.database.GetTarget (source, property, true);

  if (node)
    lb.database.Change (source, property, node, rdf.GetLiteral (aValue));
  else
    lb.database.Assert (source, property, rdf.GetLiteral (aValue), true);
}

function onListProcessAttachments (lb)
{
  var j;
  var aw = document.getElementById ("attachmentWidget");

  for (j=0; j<aw.childNodes.length; j++)
    {
      if (aw.childNodes[j].tagName == "listitem")
	{
	  aw.removeChild (aw.childNodes[j]);
	  j = 0;
	}
    }

  if (getRDFvalue (lb, "af1_name").length <= 0)
    {
      document.getElementById ("InboxAttachmentsBox").hidden = true;
      return;
    }

  document.getElementById ("InboxAttachmentsBox").hidden = false;

  onListProcessAttachmentsOneEntry (1,
                                    getRDFvalue (lb, "af1_transway"),
				    getRDFvalue (lb, "af1_name"),
				    "",
				    getRDFvalue (lb, "af1_size"),
				    getRDFvalue (lb, "af1_hash"),
                                    getRDFvalue (lb, "af1_w"));

  if (getRDFvalue (lb, "af2_name").length <= 0)
    return;
  onListProcessAttachmentsOneEntry (2,
                                    getRDFvalue (lb, "af2_transway"),
				    getRDFvalue (lb, "af2_name"),
				    "",
				    getRDFvalue (lb, "af2_size"),
				    getRDFvalue (lb, "af2_hash"),
                                    getRDFvalue (lb, "af2_w"));

  if (getRDFvalue (lb, "af3_name").length <= 0)
    return;
  onListProcessAttachmentsOneEntry (3,
                                    getRDFvalue (lb, "af3_transway"),
				    getRDFvalue (lb, "af3_name"),
				    "",
				    getRDFvalue (lb, "af3_size"),
				    getRDFvalue (lb, "af3_hash"),
                                    getRDFvalue (lb, "af3_w"));
}

function onListProcessAttachmentsOneEntry (num, transway, name, path, size, hash, where)
{
  var aw = document.getElementById ("attachmentWidget");

  var listitem = document.createElement ("listitem");
  listitem.setAttribute ("class", "addressingWidgetItem");

  var label = document.createElement ("label");
  label.setAttribute ("value", transway);
  var listcell = document.createElement ("listcell");
  listcell.appendChild (label);
  listitem.appendChild (listcell);

  var label = document.createElement ("label");
  label.setAttribute ("value", where);
  var listcell = document.createElement ("listcell");
  listcell.appendChild (label);
  listitem.appendChild (listcell);

  var label = document.createElement ("label");
  label.setAttribute ("id", "Label_af" + num + "_name");
  label.setAttribute ("value", name);
  label.setAttribute ("style", "font-weight: bold;");
  var listcell = document.createElement ("listcell");
  listcell.setAttribute ("class", "addressingWidgetCell");
  listcell.appendChild (label);
  listitem.appendChild (listcell);
  
  label = document.createElement ("label");
  label.setAttribute ("id", "Label_af" + num + "_size");
  label.setAttribute ("orgin_size", size);
  label.setAttribute ("value", commaFormat (size, ',') + " bytes");
  listcell = document.createElement ("listcell");
  listcell.setAttribute ("class", "addressingWidgetCell");
  listcell.appendChild (label);
  listitem.appendChild (listcell);

  label = document.createElement ("label");
  label.setAttribute ("id", "Label_af" + num + "_hash");
  label.setAttribute ("value", hash);
  listcell = document.createElement ("listcell");
  listcell.setAttribute ("class", "addressingWidgetCell");
  listcell.appendChild (label);
  listitem.appendChild (listcell);
  
  aw.appendChild (listitem);
}

function actDownloadAttachFile ()
{
  var inboxStrings = document.getElementById ("inboxStrings");
  var f = document.getElementById ("InboxBodyFrom");
  var l = document.getElementById ("attachmentWidget");

  if (l.selectedIndex == -1)
    {
      alert (inboxStrings.getString ("sf"));
      return;
    }

  var i = l.selectedIndex + 1;
  var qstr = "f=" + f.value
          + "&i=" + f.getAttribute ("uid")
          + "&a=" + i;

  var req = new XMLHttpRequest ();
  req.open ("POST", URL_attget, false);
  req.setRequestHeader ('Content-Type', 'application/x-www-form-urlencoded');
  req.send (qstr);

  if (req.readyState == 4 && req.status == 200)
    {
      if (req.responseText.charAt (0) == "h")
	{
	  var h = document.getElementById ("Label_af" + i + "_hash");
	  var qstr = "i=" + f.getAttribute ("uid")
	          + "&a=" + i
       	          + "&h=" + h.value
	          + "&id=" + prefs.getCharPref ("fileauction.login.userid");

	  var URL = req.responseText 
            + document.getElementById ("Label_af" + i + "_hash").value + "/"
            + document.getElementById ("Label_af" + i + "_size").getAttribute ("orgin_size") + "/"
            + document.getElementById ("Label_af" + i + "_name").value + "?" + qstr;
	  window.openDialog ('chrome://fa/content/downloads/downloads.xul', 
			     'dm', 
			     'chrome,dialog=no,resizable', 
			     URL, 
			     document.getElementById ("Label_af" + i + "_name").value,
			     document.getElementById ("Label_af" + i + "_size").getAttribute ("orgin_size"),
			     document.getElementById ("Label_af" + i + "_hash").value,
			     qstr
			     );
	}
      else if (req.responseText.charAt (0) == "2")
	alert (inboxStrings.getString ("noprivilege"));
    }
}

function enableSaveMoneyButton ()
{
  v = document.getElementById ("SaveMoneyButton");
  v.disabled = false;
}

function inboxSaveMoneyOrPayMoney ()
{
  var inboxStrings = document.getElementById ("inboxStrings");
  var f = document.getElementById ("InboxBodyFrom");
  var q = "i=" + f.getAttribute ("uid");

  var req = new XMLHttpRequest ();
  req.open ("POST", URL_savepaymoney, false);
  req.setRequestHeader ('Content-Type', 'application/x-www-form-urlencoded');
  req.send (q);

  if (req.readyState == 4 && req.status == 200)
    {
      if (!fa_error (req.responseText))
	{
	  prefs.setBoolPref ("fileauction.money.init", false);

	  if (document.getElementById ("SaveMoneyButton").label == inboxStrings.getString ("mpbutton"))
	    fa_showMsg ("대금 지불", inboxStrings.getString ("paymoney"));
	  else
	    fa_showMsg ("대금 수령", inboxStrings.getString ("savemoney"));

	  v = document.getElementById ("SaveMoneyButton");
	  v.disabled = true;
	  v = document.getElementById ("InboxMoneyBox");
	  v.hidden = true;
	  setTimeout ("enableSaveMoneyButton ()", 10000);
	}
    }
}

function deleteMail ()
{
  var lb = document.getElementById ("InboxList");
  var uid = getRDFvalue (lb, "uid");

  var req = new XMLHttpRequest ();
  req.open ("GET", URL_delmail + "?i=" + uid, false);
  req.send (null);

  if (req.readyState == 4 && req.status == 200)
    {
      if (!fa_error (req.responseText))
        fa_showMsg ("메일 삭제", "성공적으로 메일이 삭제되었습니다.");
    }
}

var gContextMenus = [ 
  ["menuitem_download", "menuitem_connecttest"],
  ["menuitem_download", "menuitem_connecttest"],
  ["menuitem_download", "menuitem_connecttest"]
];

function buildInboxContextMenu (aEvent)
{
  if (aEvent.target.id != "InboxAttachmentPopup")
    return false;
    
  var popup = document.getElementById ("InboxAttachmentPopup");
  while (popup.hasChildNodes ())
    popup.removeChild (popup.firstChild);

  var l = document.getElementById ("attachmentWidget");
  var i = l.selectedIndex;

  if (i >= 0) {
    var v = l.getItemAtIndex (i).childNodes[0].childNodes[0].value;
    
    var menus = gContextMenus[i];
    for (var i = 0; i < menus.length; ++i)
      popup.appendChild (document.getElementById (menus[i]).cloneNode (true));
    
    return true;
  }
  
  return false;
}

function openSendMailTo ()
{
  var lb = document.getElementById ("InboxList");
  
  if (lb.selectedIndex == -1)
    {
      alert ("답장할 메일을 선택하십시오.");
      return;
    }

  prefs.setCharPref ("fileauction.mail.to", getRDFvalue (lb, "from"));
  prefs.setCharPref ("fileauction.mail.subject", getRDFvalue (lb, "subject"));
  window.parent.gFileAuctionWindow.menusSelectionChangedCore ("paneSendMail");
}
