var gWindow = null;
var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                      .getService(Components.interfaces.nsIPrefBranch);
var gCurrentScreen = "";

function loginTest ()
{
  prefs.setBoolPref ("fileauction.login.status", true);
  prefs.setCharPref ("fileauction.login.userid", "t");
}

var gFileAuctionWindow = {
 previousTabStr: null,
 prefs: null,
 
 init: function ()
 {
   try 
     {
       this.setTabImage ("paneBrowse");
       initFindBar ();
       initPrefs ();
       setHelpFileURI ("chrome://fa/locale/help/help.rdf");
       this.prefsObserver ();
       setTimeout ("checkLatest ();", 2000);
     }
   catch (e)
     {
       alert (e);
     }
 },

 uninit: function ()
 {
   this.prefs.removeObserver ("", this);
   logout ();
   uninitFindBar ();
   uninitPrefs ();
 },
 
 prefsObserver: function ()
 {
   this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefService)
                          .getBranch ("fileauction.default.");
   this.prefs.QueryInterface (Components.interfaces.nsIPrefBranch2);
   this.prefs.addObserver ("", this, false);
 },

 observe: function(subject, topic, data)
 {
   if (topic != "nsPref:changed")
     return;
   
   switch (data)
     {
     case "item":
       var s = this.prefs.getCharPref ("item");
       if (s.length > 0)
         {
           changeBottomMenuToAuction (); 
           this.setTabImage ("paneBrowse");
         }
       break;
     }
 },

 /* Set the tab image of bottom menu.  it saves previous tab string and 
    changes the previous tab's style when new change be occured.  */
 setTabImage: function (nodestr)
 {
   if (this.previousTabStr != null)
     {
        var node = document.getElementById (this.previousTabStr + "-left");
	node.setAttribute ("style", "");
	var node = document.getElementById (this.previousTabStr + "-middle");
	node.setAttribute ("style", "");
	var node = document.getElementById (this.previousTabStr + "-right");
	node.setAttribute ("style", "");
	var node = document.getElementById (this.previousTabStr);
//@line 86 "/Users/weongyo/Developments/fileauction/src/chrome/content/main.js"
        node.setAttribute ("style", "");
//@line 92 "/Users/weongyo/Developments/fileauction/src/chrome/content/main.js"
     }

//@line 104 "/Users/weongyo/Developments/fileauction/src/chrome/content/main.js"

   var node = document.getElementById (nodestr);
   node.setAttribute ("selected", "false");
//@line 112 "/Users/weongyo/Developments/fileauction/src/chrome/content/main.js"
   node.setAttribute ("style", "background-color: #999999");
//@line 118 "/Users/weongyo/Developments/fileauction/src/chrome/content/main.js"

   this.previousTabStr = nodestr;
   gCurrentScreen = nodestr;
 },

 menusSelectionChanged: function (aSelectedItem)
 {
   this.menusSelectionChangedCore (aSelectedItem.id);
 },

 /* The bottom menu handler.  */
 menusSelectionChangedCore: function (name)
 {
   var paneBody = document.getElementById ('paneBody');

   closeFindBar ();
   this.setTabImage (name);
   switch (name)
     {
     case "paneToAuction":
       changeBottomMenuToAuction (); 
       this.setTabImage ("paneBrowse");
       paneBody.loadURI ("chrome://fa/content/browse.xul");
       break;
     case "paneBrowse":
       changeBottomMenuToAuction ();
       paneBody.loadURI ("chrome://fa/content/browse.xul");
       break;
     case "paneBids":
       changeBottomMenuToAuction ();
       paneBody.loadURI ("chrome://fa/content/bids.xul");
       break;
     case "paneAuctions":
       changeBottomMenuToAuction ();
       paneBody.loadURI ("chrome://fa/content/auctions.xul");
       break; 
     case "paneToMailbox":
       changeBottomMenuToMailbox ();
       this.setTabImage ("paneInbox");
       paneBody.loadURI ("chrome://fa/content/inbox.xul");
       break;
     case "paneInbox":
       changeBottomMenuToMailbox ();
       paneBody.loadURI ("chrome://fa/content/inbox.xul");
       break;
     case "paneSendMail":
       changeBottomMenuToMailbox ();
       paneBody.loadURI ("chrome://fa/content/sendMail.xul");
       break;
     }
 }
};

function getgWindow ()
{
  if (!gWindow)
    gWindow = document.getElementById ("FileAuction");

  return gWindow;
}

function changeBottomMenuToMailbox ()
{
  var i;

  i = document.getElementById ("AuctionBottomMenuVbox");
  i.setAttribute ("hidden", "true");
  i = document.getElementById ("MailboxBottomMenuVbox");
  i.setAttribute ("hidden", "false");
}

function changeBottomMenuToAuction ()
{
  var i;

  i = document.getElementById ("AuctionBottomMenuVbox");
  i.setAttribute ("hidden", "false");
  i = document.getElementById ("MailboxBottomMenuVbox");
  i.setAttribute ("hidden", "true");
}

function logout ()
{
  var req = new XMLHttpRequest ();  
  req.open ("GET", URL_logout, false);
  req.send (null);
}

function maximizeOrRestore() 
{
  if (window.windowState == window.STATE_MAXIMIZED) 
    window.restore();
  else 
    window.maximize();
} 

function onExit()
{
  document.defaultView.close();
}

function handleExit()
{
  onExit();

  var as = Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(Components.interfaces.nsIAppStartup);
  if (as)
  {
    const V_ATTEMPT = 1;
    as.quit (V_ATTEMPT);
  }
}

function menuLogin ()
{
  var mainStrings = document.getElementById ("mainStrings");

  if (checkLoginStatus ())
    {
      alert (mainStrings.getString ("alogin"));
      return;
    }

  window.openDialog ('chrome://fa/content/login.xul',
		     'login',
		     'chrome,dependent,centerscreen', 
		     0,
		     window.paneBody);
}

function menuLogout ()
{
  var mainStrings = document.getElementById ("mainStrings");

  if (!checkLoginStatus ())
    {
      alert (mainStrings.getString ("alogout"));
      return;
    }

  var req = new XMLHttpRequest ();
  req.open ("GET", URL_logout, false);
  req.send (null);

  if (req.readyState == 4 && req.status == 200)
    {
      if (req.responseText.charAt (0) == "1")
	{
	  prefs.setBoolPref ("fileauction.login.status", false);
	  prefs.setCharPref ("fileauction.login.userid", "");
	  alert (mainStrings.getString ("logout"));
	}
    }
}

// deprecated.
function initLocale ()
{
  prefs.setCharPref ("general.useragent.locale", "ko-KR");
}

function openForum (id)
{
  if (id == 0)
    {
      window.paneBody.location.href = "http://weongyo.org/project/fa/phpBB/";
      return;
    }

  var url = "http://weongyo.org/project/fa/phpBB/viewforum.php?f=" + id;
  window.paneBody.location.href = url;
}

function openAboutDialog()
{
//@line 306 "/Users/weongyo/Developments/fileauction/src/chrome/content/main.js"
  window.openDialog("chrome://fa/content/aboutDialog.xul", "About", "modal,centerscreen,chrome,resizable=no");
//@line 308 "/Users/weongyo/Developments/fileauction/src/chrome/content/main.js"
}

function getBoolPref ( prefname, def )
{
  try {
    var pref = Components.classes["@mozilla.org/preferences-service;1"]
                       .getService(Components.interfaces.nsIPrefBranch);
    return pref.getBoolPref(prefname);
  }
  catch(er) {
    return def;
  }
}

function openPreferences(paneID)
{
  var instantApply = getBoolPref ("browser.preferences.instantApply", false);
  var features = "chrome,titlebar,toolbar,centerscreen" + (instantApply ? ",dialog=no" : ",modal");
 
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
  var win = wm.getMostRecentWindow("FileAuction:Preferences");
  if (win) {
    win.focus ();
    if (paneID) {
      var pane = win.document.getElementById(paneID);
      win.document.documentElement.showPane(pane);
    }
  }
  else
    openDialog ("chrome://fa/content/preferences/preferences.xul",
		"Preferences", features, paneID);
}

function manageAccount (num)
{
  if (num == 0)
    {
      var ioservice = Components.classes["@mozilla.org/network/io-service;1"]
 	                        .getService(Components.interfaces.nsIIOService);
      var uriToOpen = ioservice.newURI ("http://www.fatalbid.com/fa/home/deposit/settle.php", null, null);
      var extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
                            .getService(Components.interfaces.nsIExternalProtocolService);
      extps.loadURI(uriToOpen, null);
      return;
    }
}

function openFileAuctionHelp ()
{
  openHelp ();
}

function openDownloads ()
{
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
  var win = wm.getMostRecentWindow("Download:Manager");
  if (win) {
    win.focus ();
  }
  else
    openDialog ('chrome://fa/content/downloads/downloads.xul',
		'dm','chrome,dialog=no,resizable');
}

function openDirectUploads ()
{
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
  var win = wm.getMostRecentWindow("Upload:Manager");
  if (win) {
    win.focus ();
  }
  else
    openDialog ('chrome://fa/content/uploads/uploads.xul',
		'um','chrome,dialog=no,resizable');
}

function openAccountManager ()
{
  window.paneBody.location.href = "http://www.fatalbid.com/fa/home/account/";
}

function openMAccountManager ()
{
  window.paneBody.location.href = "http://www.fatalbid.com/fa/home/deposit/";
}

function openCopyRightProtection ()
{
  window.paneBody.location.href = "http://www.fatalbid.com/fa/home/protection/";
}

function openAdWords ()
{
  window.paneBody.location.href = "http://www.fatalbid.com/fa/home/adwords/";
}

function openUploads ()
{
  window.paneBody.location.href = "http://file.fatalbid.com/";
}

function openLatest (v)
{
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
  var win = wm.getMostRecentWindow("FileAuction:Latest");
  if (win) {
    win.focus ();
  }
  else
    openDialog ('chrome://fa/content/latest.xul',
    'latest','chrome,dialog=no,resizable', v);
}

function trimAll (sString)
{
  while (sString.substring (0,1) == ' ')
    sString = sString.substring (1, sString.length);
  while (sString.substring (sString.length - 1, sString.length) == ' ')
    sString = sString.substring (0, sString.length - 1);

  return sString;
}

function checkLatest ()
{
  var req = new XMLHttpRequest ();
  req.open ("GET", URL_latest, false);
  req.send (null);

  if (!(req.readyState == 4 && req.status == 200))
    return;

  var c = parseFloat (FileAuction_Version);
  var v = parseFloat (trimAll (req.responseText));

  if (c >= v)
    return;

  var sv = "";
  if (prefs.prefHasUserValue ("fileauction.version.skipversion"))
    sv = prefs.getCharPref ("fileauction.version.skipversion");
  if (sv != "" && sv == v)
    return;
  prefs.setCharPref ("fileauction.version.skipversion", "");

  var t = new Date ();
  t = t.getTime ();
  var n = "";
  if (prefs.prefHasUserValue ("fileauction.version.remindme"))
    n = parseInt (prefs.getCharPref ("fileauction.version.remindme"));

  if (n != 0 
      && sv == v
      && n > t)
    return;
  prefs.setCharPref ("fileauction.version.remindme", "");

  openLatest (v);
}
