var deleteHowtoAttachMsg = 0;

function getNSIFileFromURI (f)
{
  var IOService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);

  if (typeof (f) == "string")
    {
      var tempLocalFile;

      try 
        {
          var fileHandler = IOService.getProtocolHandler('file').QueryInterface(Components.interfaces.nsIFileProtocolHandler);
          tempLocalFile = fileHandler.getFileFromURLSpec(f);
        }
      catch(e) 
        { // [[interchangeability for Mozilla 1.1]]
          try 
            {
              tempLocalFile = IOService.getFileFromURLSpec(f);
            }
          catch(ex) 
            { // [[interchangeability for Mozilla 1.0.x]]
              tempLocalFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
              IOService.initFileFromURLSpec(tempLocalFile, f);
            }
        }
      
      return tempLocalFile;
    }

  return f;
}

var boardObserver = { 
 getSupportedFlavours : function () 
 { 
   var flavours = new FlavourSet ();
   flavours.appendFlavour ("text/x-moz-url");
   flavours.appendFlavour ("application/x-moz-file", "nsIFile");
   return flavours; 
 }, 

 onDragOver: function (evt,flavour,session)
 {
 }, 

 onDrop: function (evt,dropdata,session)
 {
   var sendmailStrings = document.getElementById ("sendmailStrings");

   if (dropdata.data != "")
     {
       var f = getNSIFileFromURI (dropdata.data);

       if (!f.isFile ())
	 {
	   var s = sendmailStrings.getFormattedString ("notfile", [f.leafName]);
	   alert (s);
	   return;
	 }

       this.addFile (f);
     }
   else
     {
       alert ("dropdata.data is NULL.");
     }
 },

 addFile: function (f)
 {
   if (!deleteHowtoAttachMsg)
     {
       refreshSendmailAttachments ();
       deleteHowtoAttachMsg = 1;
     }

   var aw = document.getElementById ("attachmentWidget");
   var count = aw.getAttribute ("F_count");

   count = count * 1;
   if (count >= 3)
     return;

   /* <listitem class="addressingWidgetItem" allowevents="true">
	<listcell class="addressingWidgetCell" align="right">
	  <label style='font-weight: bold;'>Postage:</label>
	</listcell>
	<listcell class="addressingWidgetCell">
	  <label>free</label>
	</listcell>
      </listitem> */

   var listitem = document.createElement ("listitem");
   //listitem.setAttribute ("class", "addressingWidgetItem");

   var transway = "Direct";
   if (prefs.prefHasUserValue ("fileauction.mail.defaultTransWay"))
     transway = prefs.getCharPref ("fileauction.mail.defaultTransWay");

   var label = document.createElement ("label");
   label.setAttribute ("value", transway);
   var listcell = document.createElement ("listcell");
   //listcell.setAttribute ("class", "addressingWidgetCell");
   listcell.appendChild (label);
   listitem.appendChild (listcell);

   var label = document.createElement ("label");
   label.setAttribute ("value", f.leafName);
   label.setAttribute ("style", "font-weight: bold;");
   var listcell = document.createElement ("listcell");
   //listcell.setAttribute ("class", "addressingWidgetCell");
   listcell.appendChild (label);
   listitem.appendChild (listcell);

   label = document.createElement ("label");
   label.setAttribute ("value", commaFormat (f.fileSize, ',') + " bytes");
   listcell = document.createElement ("listcell");
   //listcell.setAttribute ("class", "addressingWidgetCell");
   listcell.appendChild (label);
   listitem.appendChild (listcell);

   var hash = calcHash (f)
   label = document.createElement ("label");
   label.setAttribute ("value", hash);
   listcell = document.createElement ("listcell");
   //listcell.setAttribute ("class", "addressingWidgetCell");
   listcell.appendChild (label);
   listitem.appendChild (listcell);

   aw.appendChild (listitem);

   count = count * 1;
   if (count == 0)
     aw.setAttribute ("F_count", 0);

   count++;
   aw.setAttribute ("F_count", count);

   aw.setAttribute ("F" + count+ "_TransWay", transway);
   aw.setAttribute ("F" + count+ "_Name", f.leafName);
   aw.setAttribute ("F" + count+ "_Path", f.path);
   aw.setAttribute ("F" + count+ "_FileSize", f.fileSize);
   aw.setAttribute ("F" + count+ "_Hash", hash);
 }
};

function calcHash (f)
{
  var hash = Components.classes["@fileauction.com/hash/fa;1"]
                       .createInstance(Components.interfaces.IFileAuctionHash);
  var file = Components.classes["@mozilla.org/file/local;1"]
                       .createInstance(Components.interfaces.nsILocalFile);
  file.initWithPath (f.path);

  return hash.calc (file);
}

function commaFormat (num , sep) 
{ 
  var n = '' + num;
  var numl  = n.length;
  var i = n.indexOf ('.');
  var fract = '';
  
  if (i > -1)
    {
      numl -= n.length-i;
      fract = n.substring (i);
    }
  if (numl > 3)
    {
      var s, dl = numl%3;
      var str = (dl > 0) ? n.substring(0,dl):'';
      var max = Math.floor (numl/3);
      for (i=0 ; i < max ; i++)
	{
	  s = n.substring (dl + i * 3, dl + i * 3 + 3);
	  str += (dl==0 && i==0) ? s : sep+s;
	}
      return str+fract;
    }
  else
    return n;
}
