var RDFService = "@mozilla.org/rdf/rdf-service;1";
RDFService = Components.classes[RDFService].getService();
RDFService = RDFService.QueryInterface(Components.interfaces.nsIRDFService);

var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                      .getService(Components.interfaces.nsIPrefBranch);

const NC_NS = "http://www.fbay.com/rdf#";
const NC_ROOT = "http://www.fbay.com/uploads";

var serv = null;
var FA_RDF = null;
 
var async_listener = 
{
 onSocketAccepted: function(serv, transport) 
 {
   try 
     {
       var outstream = transport.openOutputStream (1, 0, 0);
       var stream = transport.openInputStream (0, 0, 0);
       var instream = Components.classes["@mozilla.org/scriptableinputstream;1"]
                                .createInstance(Components.interfaces.nsIScriptableInputStream);
       instream.init (stream);
     }
   catch (e)
     {
       alert ("Error "+e);
     }
   
   var dataListener = 
   {
      data : "",
      return_count : 0,
      found_get : 0,
      onStartRequest: function (request, context) { },
      onStopRequest: function (request, context, status) 
      {
        instream.close ();
        outstream.close ();
      },

      onDataAvailable: function (request, context, inputStream, offset, count)
      {
        this.data = instream.read (count);

	var p = serverParseHeader (this.data, "GetParams");
        if (p != null)
	  this.found_get++;

	var q = getPathFromRequest (p);
	if (q == null)
	  {
	    instream.close();
	    outstream.close();
	    return;
	  }

        var re = RegExp ("[\n\r]{2}");
        if(this.data.match (re))
	  {
	    this.return_count++;
	    if (this.return_count > 0 && this.found_get)
	      {
		FA_RDF_AddNewUpload (p, q);

		// check file existence.
		if (checkFileExistence (q[2]))
		  {
		    sendSignalToCompany (p, q, "UploadStarted");

		    var file = Components.classes["@mozilla.org/file/local;1"]
		                         .createInstance(Components.interfaces.nsILocalFile);
		    file.initWithPath (q[2]);

                    var uri = FA_RDF_Uploading (q);

		    // found the file.
		    var webpage = "HTTP/1.1 200 OK\r\n" 
		      + "Cache-Control: must-revalidate, post-check=0, pre-check=0\r\n"
		      + "Content-Type: application/octet-stream\r\n"
		      + "Content-Length: " + file.fileSize + "\r\n"
		      + "Content-Disposition: attachment; filename=\"" + q[0] + "\"\r\n"
		      + "\r\n";
		    
		    outstream.write (webpage, webpage.length);
		    
		    var s = getPLocalFile (q[2]);
		    var FileSize = file.fileSize * 1;
		    var abnormalexit = 0;
		    while (FileSize > 0 && !abnormalexit) 
		      {
			try
			  {
			    var r = outstream.writeFrom (s, FileSize);
			    outstream.flush ();
			    FileSize = FileSize - r;

                            var percent = (100 * (file.fileSize - FileSize)) / file.fileSize;
                            setRDFProperty (uri, "ProgressPercent", "" + percent);
			  }
			catch (e)
			  {
			    alert (e);
			    abnormalexit = 1;
			  }
		      }

		    FA_RDF_SetUploadStatus (q, "Done");
		    sendSignalToCompany (p, q, "UploadFinished");
		  }
		else
		  {
		    /* Can't find file. */
		    var webpage = "HTTP/1.1 404 Not Found\r\n"
		      + "Cache-Control: no-store, no-cache, must-revalidate\r\n"
		      + "Cache-Control: post-check=0, pre-check=0\r\n"
		      + "Connection: close\r\n"
		      + "Content-Type: text/html; charset=utf-8\r\n"
		      + "\r\n"
		      + "<FileAuction> Can't find the file in the seller's computer.";
		    outstream.write (webpage, webpage.length);

		    FA_RDF_SetUploadStatus (q, "CantFindFile");
		  }

		FA_RDF_FinishUpload (q);

		instream.close();
		outstream.close();
	      }
	  }
      }
   };

   // pump takes in data in chunks asynchronously
   
   var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"]
                        .createInstance(Components.interfaces.nsIInputStreamPump);
   pump.init (stream, -1, -1, 0, 0, false);
   pump.asyncRead (dataListener,null);
 }
};

function getPLocalFile (filename)
{
  try 
    {
      netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    }
  catch (e) 
    {
      alert ("Permission to read file was denied.");
    }

  var file = Components.classes["@mozilla.org/file/local;1"]
   		       .createInstance(Components.interfaces.nsILocalFile);
  file.initWithPath (filename);

  fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
		     .createInstance(Components.interfaces.nsIFileInputStream);
  fstream.init (file, 0x01, 00004, null);

  return fstream;
}

function startServer () 
{
  var serverStrings = document.getElementById ("serverStrings");

  if (!checkTimesLogin ())
    return -1;

  if (!checkLoginStatus ())
    {
      alert (serverStrings.getString ("signin"));
      return -1;
    }

  if (serv)
    {
      alert (serverStrings.getString ("arunning"));
      return 0;
    }

  try
    {
      serv = Components.classes["@mozilla.org/network/server-socket;1"]
	               .createInstance (Components.interfaces.nsIServerSocket);
      serv.init (prefs.getIntPref ("fileauction.preferences.server.listening_port"), false, -1);
      serv.asyncListen (async_listener);

      alert (serverStrings.getString ("sstart"));
    }
  catch (e)
    {
      alert ("Ex: "+e);
    }

  openUploadsRDF ();

  return 0;
}

function stopServer ()
{
  var serverStrings = document.getElementById ("serverStrings");

  if (serv)
    {
      serv.close ();
      serv = null;
      alert (serverStrings.getString ("sstop"));
    }
  else
    {
      alert (serverStrings.getString ("snstart"));
    }
}

function serverParseHeader (h, type)
{
  var r = [];
  var a = h.split ("\r\n");
  var b = a[0].split (' ');

  if (b[0] != "GET")
    return null;

  if (type == "GetPath")
    return b[1];
  else if (type == "GetParams")
    {
      var q = b[1].substring (b[1].indexOf ('?') + 1);
      var c = q.split ('&');
      
      for (i=0; i<c.length; i++)
	{
	  var p = c[i].split ('=');
	  r.push (p[0]);
	  r.push (p[1]);
	}
      
      return r;
    }

  return null;
}

function getQueryParam (a, p)
{
  for (i=0; i<a.length; i += 2)
    {
      if (a[i] == p)
	return a[i+1];
    }

  return null;
}

function getPathFromRequest (a)
{
  var qstr = "i=" + getQueryParam (a, 'i')
          + "&a=" + getQueryParam (a, 'a')
          + "&h=" + getQueryParam (a, 'h');

  var req = new XMLHttpRequest ();
  req.open ("POST", URL_getpath, false);
  req.setRequestHeader ('Content-Type', 'application/x-www-form-urlencoded');
  req.send (qstr);

  if (req.readyState == 4 && req.status == 200)
    {
      /* login succeed == 1
         login failure == 0 */
      if (req.responseText.charAt (0) != "0")
	return req.responseText.split ("\r\n");
    }

  return null;
}

// For Server.
function sendSignalToCompany (a, q, status)
{
  var qstr = "i=" + getQueryParam (a, 'i')
          + "&a=" + getQueryParam (a, 'a')
          + "&h=" + getQueryParam (a, 'h')
          + "&s=" + status
          + "&id=" + getQueryParam (a, 'id');

  var req = new XMLHttpRequest ();
  req.open ("POST", URL_signal, false);
  req.setRequestHeader ('Content-Type', 'application/x-www-form-urlencoded');
  req.send (qstr);

  if (req.readyState == 4 && req.status == 200)
    {
      if (req.responseText.charAt (0) == "0")
	alert ("signal error");
    }
}

function checkFileExistence (path)
{
  if (path == undefined)
    return false;

  var file = Components.classes["@mozilla.org/file/local;1"]
                       .createInstance (Components.interfaces.nsILocalFile);

  file.initWithPath (path);

  return file.exists ();
}

function checkServer ()
{
  var port = prefs.getIntPref  ("fileauction.preferences.server.listening_port");
  var url = "http://fbay.maru.net/fa/server/testport.php?port=" + port;

  window.paneBody.location.href = url;
}

function getFilePathOnPrefD (filename)
{
  try {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
  } catch (e) {
    alert ("Permission to save file was denied.");
  }

  // get the path to the user's home (profile) directory
  const DIR_SERVICE = new Components.Constructor ("@mozilla.org/file/directory_service;1","nsIProperties");
  try { 
    path = (new DIR_SERVICE ()).get ("ProfD", Components.interfaces.nsIFile).path; 
  } catch (e) {
    alert ("error");
  }

  // determine the file-separator
  if (path.search (/\\/) != -1)
    path = path + "\\";
  else 
    path = path + "/";
  
  return path + filename;
}

function getFileURIFromLocalPath (path)
{
  // nsIFileProtocolHandler which can be used to convert file path to URI (file://).
  var file = Components.classes["@mozilla.org/file/local;1"]
                       .createInstance(Components.interfaces.nsILocalFile);
  file.initWithPath (path);

  if (!file.exists ())
    {
      var data = '<?xml version="1.0"?>' +
	'<RDF:RDF xmlns:UP="http://www.fbay.com/rdf#"' +
	'         xmlns:RDF="http://www.w3.org/1999/02/22-rdf-syntax-ns#">' +
	'  <RDF:Seq RDF:about="http://www.fbay.com/uploads">' +
	'  </RDF:Seq>' +
	'</RDF:RDF>';

      var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                               .createInstance(Components.interfaces.nsIFileOutputStream);
      foStream.init (file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
      foStream.write (data, data.length);
      foStream.close ();
    }

  var ios = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService (Components.interfaces.nsIIOService);
  var fileHandler = ios.getProtocolHandler ("file")
                       .QueryInterface(Components.interfaces.nsIFileProtocolHandler);

  return fileHandler.getURLSpecFromFile (file);
}

function getFileURIFromLocalPathNoCreate (path)
{
  // nsIFileProtocolHandler which can be used to convert file path to URI (file://).
  var file = Components.classes["@mozilla.org/file/local;1"]
                       .createInstance(Components.interfaces.nsILocalFile);
  file.initWithPath (path);

  var ios = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService (Components.interfaces.nsIIOService);
  var fileHandler = ios.getProtocolHandler ("file")
                       .QueryInterface(Components.interfaces.nsIFileProtocolHandler);

  return fileHandler.getURLSpecFromFile (file);
}

function openUploadsRDF ()
{
  var path = getFileURIFromLocalPath (getFilePathOnPrefD ("uploads.rdf"));

  try 
    {
      FA_RDF = RDFService.GetDataSourceBlocking (path);
    }
  catch (e) {
    alert (e);
  }
}

function addRDFUploadEntry (name, uri)
{
  var RDFContainer = '@mozilla.org/rdf/container;1';
  RDFContainer = Components.classes[RDFContainer].createInstance();
  RDFContainer = RDFContainer.QueryInterface(Components.interfaces.nsIRDFContainer);

  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);

  RDFContainer.Init (FA_RDF, rdf.GetResource (NC_ROOT));

  var uriNode = rdf.GetResource (uri);

  if (RDFContainer.IndexOf (uriNode) >= 0)
    return;
  else
    {
      initUploadFile (name, uri);
      uriNode = rdf.GetResource (uri);
    }

  RDFContainer.AppendElement (uriNode);
}

function initUploadFile (name, uri)
{
  var ctime = new Date ();

  setRDFProperty (uri, "Name", name);
  setRDFProperty (uri, "UploadAnimated", "true");
  setRDFProperty (uri, "Transferred", "");
  setRDFProperty (uri, "DateStarted", ctime.getTime () + '');
  setRDFProperty (uri, "DateEnded", "");
  setRDFProperty (uri, "ProgressPercent", "0");
  setRDFProperty (uri, "UploadState", "-1");
  setRDFProperty (uri, "File", uri);
  setRDFProperty (uri, "From", "판매자: " + prefs.getCharPref ("fileauction.login.userid"));
}

function FA_RDF_AddNewUpload (p, q)
{
  var ctime = new Date ();
  var uri = getFileURIFromLocalPathNoCreate (q[2]);

  addRDFUploadEntry (q[0], uri);
  setRDFProperty (uri, "To", "구매자: " + getQueryParam (p, 'id'));
}

function FA_RDF_FinishUpload (q)
{
  var ctime = new Date ();
  var uri = getFileURIFromLocalPathNoCreate (q[2]);

  setRDFProperty (uri, "DateEnded", ctime.getTime () + '');
}

function FA_RDF_Uploading (q)
{
  var uri = getFileURIFromLocalPathNoCreate (q[2]);

  setRDFProperty (uri, "UploadState", "0");

  return uri;
}

function FA_RDF_SetUploadStatus (q, status)
{
  var uri = getFileURIFromLocalPathNoCreate (q[2]);

  if (status == "Done")
    setRDFProperty (uri, "UploadState", "1");
  else if (stauts == "CantFindFile")
    setRDFProperty (uri, "UploadState", "2");
}

///////////////////////////////////////////////////////////////////////////////
// Utility Functions 
function setRDFProperty(aID, aProperty, aValue)
{
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);

  var db = FA_RDF;
  var propertyArc = rdf.GetResource (NC_NS + aProperty);
  
  var res = rdf.GetResource (aID);
  var node = db.GetTarget (res, propertyArc, true);
  if (node)
    db.Change (res, propertyArc, node, rdf.GetLiteral (aValue));
  else
    db.Assert (res, propertyArc, rdf.GetLiteral (aValue), true);
}

function getRDFProperty(aID, aProperty)
{
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);

  var db = FA_RDF;
  var propertyArc = rdf.GetResource(NC_NS + aProperty);
  
  var res = rdf.GetResource(aID);
  var node = db.GetTarget(res, propertyArc, true);
  if (!node) return "";
  try {
    node = node.QueryInterface(Components.interfaces.nsIRDFLiteral);
    return node.Value;
  }
  catch (e) {
    try {
      node = node.QueryInterface(Components.interfaces.nsIRDFInt);
      return node.Value;
    }
    catch (e) {
      node = node.QueryInterface(Components.interfaces.nsIRDFResource);
      return node.Value;
    }
  }
  return "";
}
