var RDFService = "@mozilla.org/rdf/rdf-service;1";
RDFService = Components.classes[RDFService].getService();
RDFService = RDFService.QueryInterface(Components.interfaces.nsIRDFService);

function UploadManager ()
{
  var uri = getFileURIFromLocalPath (getFilePathOnPrefD ("uploads.rdf"));

  this.datasource = RDFService.GetDataSourceBlocking (uri);
  this.activeUploadsCount = 0;
}

UploadManager.prototype = 
  {
    datasource: null,
    canCleanUp: true,
    activeUploadsCount: 0,
    currentDataSocket: null,

    canUpload: function ()
    {
      var msg = '현재 업로드 할 수 있습니다.';
      document.getElementById ("MsgLabel").value = msg;
      this.activeUploadsCount = 0;
    },

    addUpload: function (uri, dataSocket)
    {
      this.currentDataSocket = dataSocket;
    },

    removeDownload: function (id)
    {
      var RDFContainer = '@mozilla.org/rdf/container;1';
      RDFContainer = Components.classes[RDFContainer].createInstance();
      RDFContainer = RDFContainer.QueryInterface(Components.interfaces.nsIRDFContainer);

      var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
      RDFContainer.Init (gUploadManager.datasource, rdf.GetResource (NC_ROOT));

      var uriNode = rdf.GetResource (id);

      if (RDFContainer.IndexOf (uriNode) >= 0)
	{
	  // remove the node itself
	  var props = gUploadManager.datasource.ArcLabelsOut (uriNode);
	  while (props.hasMoreElements ())
	    {
	      var prop = props.getNext ();
	      var targets = gUploadManager.datasource.GetTargets (uriNode, prop, true);

	      while (targets.hasMoreElements ())
		{
		  var tprop = targets.getNext ();
		  gUploadManager.datasource.Unassert (uriNode, prop, tprop);
		}
	    }

	  RDFContainer.RemoveElement (uriNode, true);
	}
    },

    cancelUpload: function (id)
    {
      setRDFProperty (id, "UploadState", "3");

      if (this.currentDataSocket)
        {
          this.currentDataSocket.kill ();
          this.currentDataSocket = null;
        }
    },

    cleanUp: function ()
    {
      alert ('cleanUp');
    },
    
    saveState: function ()
    {
      try {
	var ds=this.datasource.QueryInterface (Components.interfaces.nsIRDFRemoteDataSource);
	ds.Flush ();
      } catch (e) {
	alert (e);
      }
    }
  };

function getFileURIFromLocalPath (path)
{
  // nsIFileProtocolHandler which can be used to convert file path to URI (file://).
  var file = Components.classes["@mozilla.org/file/local;1"]
                       .createInstance(Components.interfaces.nsILocalFile);
  file.initWithPath (path);

  if (!file.exists ())
    {
      var data = '<?xml version="1.0"?>' +
	'<RDF:RDF xmlns:UP="http://www.fbay.com/rdf#"' +
	'         xmlns:RDF="http://www.w3.org/1999/02/22-rdf-syntax-ns#">' +
	'  <RDF:Seq RDF:about="http://www.fbay.com/uploads">' +
	'  </RDF:Seq>' +
	'</RDF:RDF>';

      var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                               .createInstance(Components.interfaces.nsIFileOutputStream);
      foStream.init (file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
      foStream.write (data, data.length);
      foStream.close ();
    }

  var ios = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService (Components.interfaces.nsIIOService);
  var fileHandler = ios.getProtocolHandler ("file")
                       .QueryInterface(Components.interfaces.nsIFileProtocolHandler);

  return fileHandler.getURLSpecFromFile (file);
}

function getFilePathOnPrefD (filename)
{
  var path;

  try {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
  } catch (e) {
    alert ("Permission to save file was denied.");
  }

  // get the path to the user's home (profile) directory
  const DIR_SERVICE = new Components.Constructor ("@mozilla.org/file/directory_service;1","nsIProperties");
  try { 
    path = (new DIR_SERVICE ()).get ("ProfD", Components.interfaces.nsIFile).path; 
  } catch (e) {
    alert ("error");
  }

  // determine the file-separator
  if (path.search (/\\/) != -1)
    path = path + "\\";
  else 
    path = path + "/";
  
  return path + filename;
}
